/******************************************************************/
/* CHK42 - check for repeated words - Toby Thurston - 24 Feb 1997 */
/******************************************************************/
call rxfuncadd 'sysgetkey', 'rexxutil', 'sysgetkey'
'msg Checking for repeated words...'   /* say hello...            */
'mark clear'                           /* clear any marks         */
'extract /cursor/'                     /* find where we are       */
'extract /flscreen/'
lastword= ""                           /* initialize the variable */
found = 0 ; removed = 0
'top'                                  /* go to top of file       */
do until rc > 0                      /* for each line to check... */
  'extract /curline/'                  /* read the current line   */
  if curline.1 <> "" then do           /* if its not blank...     */
    line = lastword curline.1/* append it to the last word of last line*/
    lastword = word(line,words(line))/* save the last word of this line */
    do i = 1 while i < words(line)   /* for each word in the line */
      j = i + 1
      if xword(line,i) \= xword(line,j) then iterate i
      found = found + 1                /* we have a match         */
      'cursor +0' length(subword(curline.1,1,i))-length(word(curline.1,i))+1
      'mark word'                      /* mark the word           */
      ? = prompt('Word <'word(line,j)'> repeated. Delete/Skip/Edit/Quit ?',"DESQ")
      select
        when ? = "D" then do           /* user replied D          */
          'mark delete'                /* remove the marked word  */
          removed = removed + 1        /* incr count              */
          curline.1 = delword(curline.1,i,1)   /* remove word     */
          line = delword(line,j,1)     /* from line               */
          i = i - 1                    /* and back up pointer     */
        end
        when ? = "Q" then signal quit  /* user wants to stop      */
        when ? = "E" then do           /* user wants to stop here */
          'mark clear'
          'msg'
          'refresh'
          exit
        end
      otherwise              /* user must have replied S for Skip */
      end
      'msg Checking for repeated words...'     /* say hello...    */
      'refresh'                        /* show the message        */
    end                                /* End loop through line   */
  end
  'down'
end                                    /* End do                  */
quit:
'cursor' flscreen.1 -1 /* -1 seems to be needed, don't ask me why */
'pagedown'
'cursor' cursor.1 cursor.2
'mark clear'
/* msg & leave             */
'msg CHK42 complete.  Found:' found ' Removed:' removed
exit
xword: procedure
  arg string,ptr
  return space(translate(word(string,ptr),"      ",".,;)(?"),0)
prompt: procedure
  parse arg message, values
  ? = ""
  values = translate(values)
  do until pos(?,values) > 0
    'msg' message
    'refresh'
    ? = translate(sysgetkey('NOECHO'))
  end
  return ?
