/***************************************************************************/
/*                                                                         */
/* GETNSET.X                                                               */
/*                                                                         */
/* While looking at a C++ variable definition, write Get and Set methods   */
/* for that variable.                                                      */
/*                                                                         */
/* Written by Blair Thompson, October 2, 1998                              */
/* If variable begins with underscore, remove it, July 2, 1999             */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /CURLINE/'
  Parse Var curline.1 varinfo ';' .
  If words(varinfo) = 2
    Then Parse Var varinfo vartype varname .
    Else Do                                             /* 2 words for type*/
      vartype = subword(varinfo,1,2)
      varname = word(varinfo,3)
    End

  vartype = Strip(vartype)
  varname = Strip(varname)
  If varname = ''
    Then Do
      'msg cursor must be pointing to a class variable definition'
      Exit
    End                                                           /* End do*/

  If Pos(substr(vartype,1,1),'aeiouAEIOU') > 0
    Then newvar = 'an'vartype
    Else newvar = 'a'vartype
  newvar = space(newvar,0)

  indent = Length(curline.1) - Length(strip(curline.1,'L'))
  If Substr(varname,1,1) = '_'
    Then funcname = Substr(varname,2)
    Else funcname = varname
  Parse Var funcname init 2 rest .
  funcname = Translate(init) || rest
  If Length(vartype) > 13
    Then retlen = Length(vartype)
    Else retlen = 14

  'INPUT' Left('',indent) || Left(vartype,retlen) 'get'funcname '() const {return' varname';};'
  'INPUT' Left('',indent) || Left('void',retlen)  'set'funcname '('vartype newvar') {'varname '=' newvar';};'

  'MARK CLEAR'                                 /* Mark it for easier moving*/
  'MARK LINE'
  'UP'
  'MARK LINE'
Exit
