/***************************************************************************/
/*									   */
/* Hide the marked area by excluding all the marked lines.  The entire     */
/* line will be excluded from the display, even if the mark is a block     */
/* mark.								   */
/*									   */
/* Written by B. Thompson, January 23, 1995				   */
/* Fix for case where some marked lines are already excluded from Cindy    */
/* Ross, October 19, 1996						   */
/*									   */
/***************************************************************************/

  'EXTRACT /MARK/'
  If mark.0 = 0
    Then Exit				       /* No marked area to exclude*/

  If mark.6 = 0
    Then 'X' mark.1				   /* Switch to marked file*/

  'EXTRACT /SHADOW/'
  'EXTRACT /MSGMODE/'
  'MSGMODE OFF'
  'SHADOW ON'

  Do i = mark.2 To mark.3
    'CURSOR' i
    'EXTRACT /curline/'
    visible = curline.2
    If visible
      Then 'EXCLUDE'
  End
  'CURSOR' mark.2
  'SHADOW' shadow.1
  'MSGMODE' msgmode.1
Exit
