/***************************************************************************/
/*                                                                         */
/* Input a line with a comment containing my name and the date.            */
/*                                                                         */
/* Useful when assigned to a syntax expansion macro (in version 1.67 and   */
/* above):                                                                 */
/*                                                                         */
/*   expand_keyword     = id                                               */
/*   expand_macro       = "id"                                             */
/*                                                                         */
/* Written by B. Thompson, September 22, 1995                              */
/* Updated January 20, 1996 for version 1.72, to input a new line          */
/*                                                                         */
/***************************************************************************/

  id = 'B. Thompson'                                             /* My name*/
  'EXTRACT /COMMENTS/'                      /* Get current file information*/
  'EXTRACT /MARGINS/'

  Parse value date('L') with dd mm yy
  outline = comments.1 || 'Written by' id',' mm dd',' yy
  'INPUT' Left(outline, margins.4 - length(comments.2)) || comments.2
Exit
