/***************************************************************************/
/* This macro generates the centuries old filler text - "Lorem inpsum..."  */
/* Usage: lorem [n] where n is the number of extra sentences you want      */
/*                                                                         */
/* See http://www.ora.com/homepages/comp.fonts/FAQ/cf_36.htm#SEC144        */
/***************************************************************************/
arg sentences .
if \datatype(sentences,"W") then sentences = 1
if sentences < 1 then sentences = 1
if sentences > 14 then sentences = 14

sentence.1 = "At ver eos et accusam dignissum qui blandit est praesent luptatum delenit aigue excepteur sint occae."
sentence.2 = "Bis nostrud exercitation ullam mmodo consequet."
sentence.3 = "Duis aute in voluptate velit esse cillum dolore eu fugiat nulla pariatur."
sentence.4 = "Et harumd dereud facilis est er expedit distinct."
sentence.5 = "Et tam neque pecun modut est neque nonor et imper ned libidig met, consectetur adipiscing elit, sed ut labore et dolore magna aliquam."
sentence.6 = "Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
sentence.7 = "Irure dolor in reprehend incididunt ut labore et dolore magna aliqua."
sentence.8 = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed eiusmodem tempo incidunt et labore et dolore magna aliquam."
sentence.9 = "Nam soluta nobis eligent optio est congue nihil impedit doming id."
sentence.10= "Nam liber te conscient to factor tum poen legum odioque civiuda."
sentence.11= "Neque pecun modut est neque nonor et imper ned libidig met, consectetur adipiscing elit, sed ut labore et dolore magna aliquam is nostrud exercitation ullam mmodo consequet."
sentence.12= "Officia deserunt mollit anim id est laborum."
sentence.13= "Tia non ob ea soluad incommod quae egen ium improb fugiendum est."
sentence.14= "Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat."

sequence = permute(14,sentences)
out = sentence.8 || " "
do i = 1 to words(sequence)
  j = word(sequence,i)
  out = out sentence.j || " "/* the space on the end is needed below */
end

linesize = 68

Do Until out = ''
  k=lastpos(' ',out,min(linesize,length(out)))
  "input" strip(left(out,k))
  out = strip(substr(out,k+1),'l')
End

exit

permute: procedure/* return n distinct integers from {1..c} in random order*/
  arg c, n
  if n > c then n = c
  out = ""
  do forever
    ? = random(1,c)
    if wordpos(?,out) = 0 then out = out ?
    if words(out) = n then leave
  end
return out
