/* SHEL.X:  Execute OS/2 commands, and display the result in a file view */
/* Written by Phil Hobbs, October 15, 1997                               */

call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs
call sysloadfuncs

/* trace r */
parse arg command
command=strip(command)
If command = '' then do
   "MSG Nothing to do!"
   return -1;
end

queuename=rxqueue('Create')
oldqueue=rxqueue('Set', queuename);

signal on halt

e 'shell.out /Q'

dir=Directory()                              /* make fake command prompt $p] */
queue dir"]"command                          /* where ']' is a right bracket */

"MSG Shelling command '"command"'"
If left(command,1) \= '@' then command = '@' || command

crlf='0d0a'x
command '2>&1 | rxqueue' queuename

Do queued()
   results=linein("QUEUE:");
   'input' results
End/* End do*/

'refresh'

halt:
call rxqueue 'Set', oldqueue;
call rxqueue 'Delete', queuename;
return 0
