/***************************************************************************/
/*                                                                         */
/* Compare two files.  Return 0 if they are the same, or non-zero if they  */
/* are different.  We quit from each file before we exit.  The most useful */
/* way to use this is from an OS/2 FULIST-clone (I use OS2FL):             */
/*                                                                         */
/*   X fn1 fn2 /TOP /CCOMP                                                 */
/*                                                                         */
/* Uses QUITALL.X macro                                                    */
/*                                                                         */
/* Written by B. Thompson, November 26, 1993                               */
/* Ensure there are 2 files in the ring, August 25, 1997                   */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /RING/'
  If ring.0 < 2
    Then Exit                             /* Insufficient files in the ring*/

  'TOP'                                                        /* This file*/
  'NEXT_FILE'
  'TOP'                                                    /* The next file*/
  'COMPARE'
  'EXITRC' rc
  'QUITALL'
Exit
