/******************************************************************/
/* Copy down -- fill a block mark with the top line of the mark   */
/* Toby Thurston - 28 Aug 1997                                    */
/******************************************************************/
'extract /mark/'                       /* get the mark (if any)   */
select                                 /* check mark is ok        */
  when mark.0 = 0 then "msg Nothing marked! Mark a block with the text to copy at the top"
  when mark.6 = 0 then "msg Mark exists off screen in" mark.1
  when mark.4 = 0 then "msg I need a block mark not a line mark."
  when mark.2 = mark.3 then "msg Extend the mark down..."
otherwise                              /* mark is ok now          */
  'extract /cursor/'                   /* remember where we were  */
  'extract /line' mark.2'/'            /* get the line            */
  s = substr(line.1,mark.4,mark.5-mark.4+1)  /* get the substring */
  'cursor begmark'                    /* move to top left of mark */
  'insmode off'                        /* overwrite not insert    */
  s = translate(s,'01'x," ")           /* preserve leading blanks */
  do mark.3 - mark.2                   /* for lines 2..n of mark  */
    'cursor +1' mark.4                 /* move down & stay left   */
    'extract /curline/'
    if curline.2                       /* not hidden              */
      then 'keyin' s                   /* insert the substring    */
  end
  'cursor begmark'                     /* cursor to top of mark   */
  'c/' || '01'x || '/ /m*'             /* put spaces back         */
  'cursor' cursor.1 cursor.2           /* put the cursor back     */
  'msg'                                /* remove the changed msg  */
end
'refresh'                              /* dismiss the cmd line    */
exit
