/***************************************************************************/
/*                                                                         */
/* Display the results of a DIR command in a file.  Each line contains a   */
/* file which can be opened with the Ctrl-P key.                           */
/*                                                                         */
/* Requires X version 1.34 or later.                                       */
/*                                                                         */
/* Written by B. Thompson, February 21, 1994                               */
/*                                                                         */
/***************************************************************************/

  Parse Arg dirinfo
  tempfile = '$TEMP$.DIR'
  Address CMD '@DIR' dirinfo '>'tempfile

  'X .DIR'
  'TOP'
  'DELETE *'                                    /* Make sure we start clean*/
  'GET' tempfile
  'ALT 0 0'                                           /* Allow user to quit*/

  Address CMD '@ERASE' tempfile                                  /* Cleanup*/
Exit
