/***************************************************************************/
/*                                                                         */
/* Document changed lines in a source file by adding a comment to each     */
/* line.  Best called with some kind of identifier, e.g. "DOC BWT" to add  */
/* initials and the date to each changed line.  Must be called before      */
/* saving the file to disk.                                                */
/*                                                                         */
/* Written by B. Thompson, May 25, 1994                                    */
/* Turn LINEND off, January 17, 1996 (requires version 1.72)               */
/*                                                                         */
/***************************************************************************/

  Parse Arg text                               /* Get supplied comment text*/
  text = Strip(text) '('date('S')')'                    /* Add today's date*/
  'CHANGES'
  If rc <> 0
    Then Exit                                     /* No changed lines found*/

  'EXTRACT /COMMENTS/'                               /* Get comment markers*/
  'EXTRACT /LINEND/'                                 /* Save linend setting*/
  'EXTRACT /MSGMODE/'
  'MSGMODE OFF'
  'LINEND OFF'                                        /* Make sure it's off*/

  'TOP'
  rc = 0
  Do While rc = 0
    'EXTRACT /CURLINE/'
    If curline.1 <> ''
      Then 'REPLACE' curline.1 comments.1 text comments.2
    'DOWN'
  End                                                             /* End do*/

  'LINEND' linend.1                                       /* Restore linend*/
  'MSGMODE' msgmode.1
Exit
