/***************************************************************************/
/*                                                                         */
/* Input a comment box for documenting the current C or C++ function.      */
/* Includes the function name within the box.  A possible enhancement is   */
/* to include the function parameters and the return value.                */
/*                                                                         */
/* Requires editor version 1.74 or later.                                  */
/*                                                                         */
/* Written by Blair Thompson, February 21, 1996                            */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /COMMENTS/'                      /* Get current file information*/
  'EXTRACT /MARGINS/'
  'EXTRACT /CURSOR/'

  comments.1 = strip(comments.1)
  If substr(comments.1,length(comments.1)) <> '*'
    Then comments.1 = comments.1 || '*'
  comments.1 = comments.1 || ' '
  If comments.2 = ''
    Then comments.2 = '*'                            /* Close a box comment*/
  fillspace = margins.4 - length(strip(comments.1)) - length(strip(comments.2))
  sep = strip(comments.1) || left('', fillspace, '*') || strip(comments.2)
  fillspace = margins.4 - length(comments.1) - length(comments.2)
  blank = comments.1 || left('', fillspace) || comments.2
  cmt_col = length(comments.1) + 1

  'NEXT_FUNC'
  'EXTRACT /CURLINE/'
  Parse Var curline.1 prefix '(' .          /* Strip off function arguments*/
  funcname = Word(prefix, Words(prefix))

  'CURSOR' cursor.1                              /* Restore cursor position*/
  'INPUT #pragma page()'
  'INPUT' sep
  'INPUT' blank
  'INPUT' Overlay(funcname, blank, cmt_col)
  'INPUT' blank
  'INPUT' blank
  'INPUT' blank
  'INPUT' sep
  'INPUT'
  'CURSOR -3' cmt_col
Exit
