/***************************************************************************/
/* This macro generates some vaguely middle-European filler text           */
/* Usage:  gwook [n] where n is the number of sentences you want           */
/*                                                                         */
/***************************************************************************/
arg sentences .
if \datatype(sentences,"W") then sentences = 1
if sentences < 1 then sentences = 1
if sentences > 18 then sentences = 18

sentence.1 = "Aslu unaffoctor gef cak siructiun gill bo cak spiarshoot anet cak GurGanglo gur pwucossing pwutwam."
sentence.2 = "Cak pwico siructiun ruos nust apoply tyu cak UCU sisulutiun munityuw uw cak UCU-TGU jot scannow."
sentence.3 = "Cak pwico vux bolug incluros all uf cak sirucor hawrgasi itoms alung gith cakiw nog pwicos."
sentence.4 = "Eslo idaffacgad gef trenz beynocguon quiel ba trenz Spraadshaag ent trenz dreek wirc procassidt program."
sentence.5 = "Ghat dodtos, ig pany, gill bo maro tyu ucakw suftgasi pwuructs hod yot tyubo rotowminor."
sentence.6 = "Hei muk neme eis loppe."
sentence.7 = "Offoctivo immoriatoly, hawrgasi pwicos asi sirucor."
sentence.8 = "Piy opher hawers, eit yaggles orn ti sumbloat alohe plok."
sentence.9 = "Plasa maku noga wipont trenzsa schengos ent kaap zux copy wipont trenz kipg naar mixent phona."
sentence.10= "Plloaso mako nuto uf cakso dodtos anr koop a cupy uf cak vux noaw yerw phuno."
sentence.11= "Su havo loasor cakso tgu pwuructs tyu InfuBwain, ghu gill nug bo suloly sispunsiblo fuw cakiw salo anr ristwibutiun."
sentence.12= "Thas sirutciun applios tyu thuso itoms ghuso pwicos gosi sirucor in mixent gosi sirucor",
             "ic mixent ples cak ontisi sowios uf Zerm hawr rwivos."
sentence.13= "Treas em wankeing ont sime ploked peish rof phen sumbloat syug si phat phey gavet peish ta paat ein pheeir sumbloats."
sentence.14= "Trens roxas eis ti Plokeing quert loppe eis yop prexs."
sentence.15= "Trenz pruca beynocguon doas nog apoply su trenz ucu hugh rasoluguon monugor or trenz ucugwo jag scannar."
sentence.16= "Unte af phen neige pheings atoot Prexs eis phat eit sakem eit vory gast te Plok peish ba useing phen roxas."
sentence.17= "Wa hava laasad trenzsa gwo producgs su IdfoBraid, yop quiel geg ba solaly rasponsubla rof",
"trenzur sala ent dusgrubuguon."
sentence.18= "Whag schengos, uf efed, quiel ba mada su otrenzr swipontgwook proudgs hus yag su ba dagarmidad."

sequence = permute(18,sentences)
out = ""
do i = 1 to words(sequence)
  j = word(sequence,i)
  out = out sentence.j || " "       /* the space on the end is needed below*/
end

linesize = 68

"input"                                /* a blank line                     */

Do Until out = ''
  k=lastpos(' ',out,min(linesize,length(out)))
  "input" strip(left(out,k))
  out = strip(substr(out,k+1),'l')
End

exit

permute: procedure/* return n distinct integers from {1..c} in random order*/
  arg c, n
  if n > c then n = c
  out = ""
  do forever
    ? = random(1,c)
    if wordpos(?,out) = 0 then out = out ?
    if words(out) = n then leave
  end
return out
