/***************************************************************************/
/*                                                                         */
/* Exclude all blank lines from the display.  The lines remain part of the */
/* file, but are not visible.  A slight modification of NOBLANKS.X.        */
/*                                                                         */
/* Written by B. Thompson, February 15, 1995                               */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /CURSOR/'                                         /* Save cursor*/
  'CURSOR 1 1'                                       /* Position the cursor*/
  'MARK CLEAR'                                /* Make sure there is no mark*/
  'MARK BLOCK'                                    /* Start a new block mark*/
  'BOTTOM'
  'MARK BLOCK'                                 /* Mark column 1 of the file*/
  'ALL ?? LM-'                                    /* Remove all blank lines*/
  'MARK CLEAR'
  'CURSOR' cursor.1 cursor.2                          /* Restore the cursor*/
Exit
