/***************************************************************************/
/*                                                                         */
/* Find the longest line in a file.                                        */
/*                                                                         */
/* Written by B. Thompson, January 20, 1995                                */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /SIZE/'
  'TOP'
  max_len = 0
  best_line = 0
  Do line = 1 to size.1
    'EXTRACT /CURLINE/'
    If length(curline.1) > max_len
      Then Do                                        /* This line is longer*/
        max_len = length(curline.1)
        best_line = line
      End                                                         /* End if*/
    'DOWN'
  End                                                             /* End do*/
  'CURSOR' best_line                                  /* Go to longest line*/
  'MSG Longest line is' max_len 'bytes long'
Exit
