/***************************************************************************/
/*									   */
/* MAN.X								   */
/*									   */
/* Display the results of a Unix MAN command in an editor window.  If the  */
/* user profile has been set up correctly, we'll get syntax highlighting   */
/* to make the information easier to read.				   */
/*									   */
/* Based on an idea by Gautam H. Mudunuri <gmudunur@informatica.com>       */
/* Written by Blair Thompson, August 5, 1998				   */
/* Remove dependence on BASH shell, September 30, 1998			   */
/*									   */
/***************************************************************************/

  Parse Arg maninfo
  tempfile = '_TEMP_.MAN'
  'SHELL man' maninfo '| col -bx >'tempfile

  'X .MAN'
  'TOP'
  'DELETE *'					/* Make sure we start clean*/
  'GET' tempfile
  'ALT 0 0'					      /* Allow user to quit*/

  'SHELL rm' tempfile						 /* Cleanup*/
Exit
