/* MarkMat.X    ... by Cindy Ross                  */

/* Mark the set of lines within a pair of matching */
/* characters (such as braces).                    */

/* New version to do a block mark instead of a     */
/* line mark when the match occurs within a line.  */
/* Also modified to optionally use extend marking. */

parse arg extend

'EXTRACT /CURSOR/'
row = CURSOR.1
col = CURSOR.2

'match'

'EXTRACT /CURSOR/'
newrow = CURSOR.1

if ( row = newrow ) then
do
   'mark block' extend
   'cursor' row col
   'mark block' extend
end
else
do
   'mark line' extend
   'cursor' row col
   'mark line' extend
end
