/******************************* NEWLINE.X *********************************/
/*                                                                         */
/* X2 macro to add a new line if INSERT mode is on, otherwise just cursor  */
/* to the next line. In either case place cursor under the first non-blank */
/* character in previous line. Modify DEF file as follow:                  */
/*  key enter = macro NEWLINE                                              */
/*                                                                         */
/* Written by Wing F. Yuen                              WFY316 at PKMFGVM1 */
/*                                                             21 Feb 1994 */
/************************************************************************* */

c = 'COMMAND'
c 'EXTRACT /INSERT/'

if INSERT.1 = 1 then do
   c 'EXTRACT /CURLINE/'
   c 'INPUT'
   end
else do
   c 'DOWN'
   c 'EXTRACT /CURLINE/'
end

c 'CURSOR +0' COMPARE(' ', CURLINE.1, ' ')    /* return 1st mismatch column*/

Exit

/* if you prefer the REPLACE mode Enter key to go to column one of the     */
/* next line, use this version instead.                                    */

if INSERT.1 = 1 then do
   c 'EXTRACT /CURLINE/'
   c 'INPUT'
   c 'CURSOR +0' COMPARE(' ', CURLINE.1, ' ')
   end
else do
   c 'DOWN'
   c 'CURSOR +0 1'
end

Exit
