/***************************************************************************/
/*                                                                         */
/* Remove all blank lines from the current file.  Requires version 1.48 of */
/* the editor or later.                                                    */
/*                                                                         */
/* Written by B. Thompson, October 7, 1994                                 */
/*                                                                         */
/***************************************************************************/

  'ALL'                             /* Make sure we can see the entire file*/
  'CURSOR 1 1'                                       /* Position the cursor*/
  'MARK CLEAR'                                /* Make sure there is no mark*/
  'MARK BLOCK'                                    /* Start a new block mark*/
  'BOTTOM'
  'MARK BLOCK'                                 /* Mark column 1 of the file*/
  'ALL // LM'                                   /* Display only blank lines*/
  'TOP'
  'DELETE *'                                                  /* Remove 'em*/
  'ALL'                                     /* Show all the remaining lines*/
  'MARK CLEAR'
Exit
