/***************************************************************************/
/*                                                                         */
/* PRTCODES.X                                                              */
/*                                                                         */
/* Create a window with various proprinter control codes.  When one is     */
/* selected, input it into the current cursor position.  A replacement for */
/* the old builtin PRTCODEWIN function.                                    */
/*                                                                         */
/* Written by Blair Thompson, April 14, 1998                               */
/*                                                                         */
/***************************************************************************/

  'WINDOW 10 50 26 ProPrinter Control Codes'
  "WINLINE High Quality (NLQ Font)     \nKEYIN" '1B'x || "G" || '1B'x || "J$"
  "WINLINE Printer reset               \nKEYIN" '1B'x || "@ " || '1B'x || "J$"
  "WINLINE 8 lines per inch            \nKEYIN" '1B'x || "0"
  "WINLINE 10 characters per inch      \nKEYIN" '12'x
  "WINLINE 12 characters per inch      \nKEYIN" '1B'x || ":"
  "WINLINE Accented Characters         \nKEYIN" '1B'x || "6"
  "WINLINE New Page                    \nKEYIN" '0C'x
  "WINLINE Single space                \nKEYIN" '1B'x || "A" || '0C'x || '1B'x || "J$"
  "WINLINE 1-1/2 space                 \nKEYIN" '1B'x || "A" || '12'x || '1B'x || "J6"
  "WINLINE Double space                \nKEYIN" '1B'x || "A" || '18'x || '1B'x || "JH"
  "WINLINE Regular font                \nKEYIN" '1B'x || "H" || '1B'x || "J$"
  "WINLINE Skip perforation ON         \nKEYIN" '1B'x || "N"
  "WINLINE Skip perforation OFF        \nKEYIN" '1B'x || "O" || '1B'x || "J$"
  "WINLINE Emphasized ON               \nKEYIN" '1B'x || "E"
  "WINLINE Emphasized OFF              \nKEYIN" '1B'x || "F"
  "WINLINE Compressed (Condensed) ON   \nKEYIN" '0F'x
  "WINLINE Compressed OFF              \nKEYIN" '12'x
  "WINLINE Underline ON                \nKEYIN" '1B'x || "-1"
  "WINLINE Underline OFF               \nKEYIN" '1B'x || "-0"
  "WINLINE Expanded ON                 \nKEYIN" '1B'x || "W1"
  "WINLINE Expanded OFF                \nKEYIN" '1B'x || "W0"
  "WINLINE Double Strike ON            \nKEYIN" '1B'x || "G"
  "WINLINE Double Strike OFF           \nKEYIN" '1B'x || "H"
  "WINLINE Superscript ON              \nKEYIN" '1B'x || "S0"
  "WINLINE Subscript ON                \nKEYIN" '1B'x || "S1"
  "WINLINE Super/subscript OFF         \nKEYIN" '1B'x || "T"
Exit
