/***************************************************************************/
/*                                                                         */
/* REMOVEXT.X                                                              */
/*                                                                         */
/* Remove all files from the ring that have the supplied file extension.   */
/*                                                                         */
/* Written by Blair Thompson, September 3, 1996                            */
/*                                                                         */
/***************************************************************************/

  Parse Upper Arg bad_ext .
  If bad_ext = ''
    Then Do
      'MSG Parameter is the unwanted extension'
      Exit
    End


  'EXTRACT /RING/'                               /* How many files in ring?*/
  docsfound = 0
  Do i = 1 To ring.0
    'NEXT_FILE'
    'EXTRACT /NAME/'

    ext = Lastpos('.',Name.1)
    If ext = 0
      Then Iterate                                 /* File has no extension*/

    ext = Translate(Substr(Name.1,ext+1))
    If ext = bad_ext
      Then Do                         /* Remove file from ring if unchanged*/
        'EXTRACT /ALT/'
        If alt.2 = 0 & docsfound + 1 < ring.0
          Then Do
            docsfound = docsfound + 1
            'QQUIT'
          End
      End
  End                                                             /* End do*/

  'MSG' docsfound 'file(s) with extension' bad_ext 'were removed from ring'
Exit
