/******************************************************************/
/* STDIN.X                            Toby Thurston - 28 Feb 1996 */
/*                                                                */
/* Syntax:  ... | x /cSTDIN /q                                    */
/*                                                                */
/* Description:  Read lines from STDIN into the current file.     */
/* Use from the command line after a pipe connector, with the     */
/* x command and the /c switch.  Add the /q switch to stop        */
/* X2 saying "New File" on the bottom of the screen too early.    */
/******************************************************************/
'name .STDIN'                                         /* temp name for file*/
Do While Lines('stdin') > 0                        /* read lines from STDIN*/
 'input' linein('stdin')
end
'top'                                  /* back to top             */
'alt 0 0'                              /* allow user to quit      */
exit
